#!/usr/bin/php -q
<?php

function main() {

$arg = get_options();
$argumento = $arg['a'];
$community = $arg['c'];
//Se o parametro ifAlias for "Loacal Area connection [1-9] ele coloca o "*", pois o snmp funciona com *
$pattern = '/(Connection)(\s[0-9])/i';
$replacement = '$1*$2';
$replace = preg_replace($pattern, $replacement, $argumento);
$argumento = $replace;
//var_dump($argumento);

if (!strpos($argumento,'-s') ) {
	if(empty($community)){
		echo "Passar a community -c\n";
		help();
	}
    $speed_interface = getSpeedInterface($argumento, $community);
    $speed_interface =  $speed_interface /  1000; // Speed(Kbps)
    $speed_interface = "-s ".$speed_interface;
    //echo "nao tinha speed \n";
}else{
	//echo "Tinha speed \n";
	$speed_interface = "";
}

$cmd = "/usr/local/opmon/libexec/opservices/op-snmp-interface ".$argumento." ".$speed_interface;
//var_dump($cmd);

$last_line = system($cmd, $exit_cmd_op);

//Se for Administrative DOWN exit code deve ser 2
if(preg_match('/Administrative DOWN/', $last_line)){
	$exit_cmd_op = 2;
}

//quit($last_line, $retval);
exit($exit_cmd_op);
 	
}	


function get_options() {
	$shortopts  = "a:c:";
	$longopts  = array("arg:"); 	
	$options = getopt($shortopts, $longopts);

	return $options;

}

function quit($text, $code) {
    echo $text."\n";
    exit($code);
}
function help() {
	$basename = str_replace(".php", "", basename($_SERVER[PHP_SELF]));
	$texto = "./$basename ... ";

	quit($texto, 3);	
}

function getSpeedInterface($argumento, $community) {
	//Busca velocidade da interface
	//pega ip do argumento
	//
	$pattern = '/-h(.*)-i/';
	preg_match($pattern, $argumento, $res_ip);
	//print_r($res_ip);exit;
	$ipAndPort = $res_ip[1];

	//busca index
	$pattern = '/\'(.*)\'/';
	preg_match($pattern, $argumento, $matches);
	//print_r($matches);
	$ifAlias = $matches[0];
	//var_dump($ifAlias);
	$ifAlias_snmp  = str_replace("*", "\*", $ifAlias);

	$snmpwalkSearchId = exec( "snmpwalk -v 2c -c $community $ipAndPort ifDescr | grep  -i ".$ifAlias_snmp."$", $foo, $exit_code);
	//var_dump($snmpwalkSearchId);

	//var_dump($exit_code);
	if($exit_code != 0) exit(3);

	$pattern = '/ifDescr.([0-9]+)/';
	preg_match($pattern, $snmpwalkSearchId, $res);
	//print_r($res);
	$interface_id = $res[1];
	//var_dump($interface_id);

	$snmpwalkSearchSpeed = exec( "snmpwalk -v 2c -c $community $ipAndPort 1.3.6.1.2.1.2.2.1.5.$interface_id", $foo, $exit_code);
	if($exit_code != 0) exit(3);
	//var_dump($snmpwalkSearchSpeed);
	$pattern = '/:.([0-9]+)/';
	preg_match($pattern, $snmpwalkSearchSpeed, $res_speed);
	//print_r($res_speed);
	$speed_interface = $res_speed[1];
	//var_dump($speed_interface);
    return $speed_interface;
}


main();
?>
