#!/bin/bash

ERRORS=0
if [ -f /var/log/cmdb-sync.log ]; then
	ERRORS=`tail -n 100 /var/log/cmdb-sync.log | grep '\[error\]' | wc -l`
fi

if [ $ERRORS -gt 0 ]; then
	echo "Existem $ERRORS erros de sincroniza no log /var/log/cmdb-sync.log"
	exit 2
fi

echo "Sem erros de sincronia"
exit 0
