#!/usr/bin/php -q
<?php

/*
*Array com os codigos e seu significados para cada OID
*/
$returnOIDsForHuman = array(
	'.1.3.6.1.4.1.318.1.1.1.4.1.1.0' => // Basic Output Status (On-line)
	array( 
		1 => 'Unknown',
		2 => 'On Line',
		3 => 'On Battery',
		4 => 'On Smart Boost',
		5 => 'Timed Sleeping',
		6 => 'Software Bypass',
		7 => 'Off',
		8 => 'Rebooting',
		9 => 'Switched Bypass',
		10 => 'Hardware Failure Bypass',
		11 => 'Sleeping Until Power Returns',
		12 => 'On Smart Trim', 
	) ,

	'.1.3.6.1.4.1.318.1.1.1.2.1.1.0' => // Battery Status
 	array( 
		1 => 'Unknown',
		2 => 'Battery Normal',
		3 => 'Battery Low',
	) ,

	'.1.3.6.1.4.1.318.1.1.1.2.2.4.0' => // Replace Battery
		array( 
		1 => 'Batteries do not need replacing',
		2 => 'Batteries need replacing',
	) ,
);

/*
*Verifica se o parametro -o exite e pega o valor de oid pra $oid
*/
$argumento = implode(" ", $argv);
$temOid = false;
foreach ($argv as $key => $value) {
	if($value === "-o"){
		$temOid = true;
		$oid = $argv[$key+1];
	}
}

/*
*Executa o comando
*/
$cmd = "/usr/local/opmon/libexec/check_snmp ".$argumento;
//var_dump($cmd);

$output = exec($cmd, $foo ,$exitCodeCmd);

/*
*se tem oid ele busca as possiveis retornos e guarda em $returnForHuman
*/
if($temOid){
	foreach ($returnOIDsForHuman as $key => $values) {
		if($oid == $key){
			$returnForHuman = $values;
		}
	}
}

/*
*Se existe $returnForHuman ele troca a mensagem de valor para a mensagem correta
*/
if($returnForHuman){
	$arr_output = explode("|", $output);
	//var_dump($arr_output[0]);
	$pattern = '/[0-9]/';
	preg_match($pattern, $arr_output[0], $code);
	$statusCode = $code[0];
	$firtOut = str_replace($statusCode,'- '.$returnForHuman[$statusCode], $arr_output[0]);	
	$output = $firtOut."|".$arr_output[1];
}

print $output."\n";
exit($exitCodeCmd);



?>